<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEkSecenekDeger ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfEkSecenekDeger
 * @subpackage Arrays
 */
class ArrayOfEkSecenekDeger extends AbstractStructArrayBase
{
    /**
     * The EkSecenekDeger
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EkSecenekDeger[]
     */
    public $EkSecenekDeger;
    /**
     * Constructor method for ArrayOfEkSecenekDeger
     * @uses ArrayOfEkSecenekDeger::setEkSecenekDeger()
     * @param \StructType\EkSecenekDeger[] $ekSecenekDeger
     */
    public function __construct(array $ekSecenekDeger = array())
    {
        $this
            ->setEkSecenekDeger($ekSecenekDeger);
    }
    /**
     * Get EkSecenekDeger value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EkSecenekDeger[]|null
     */
    public function getEkSecenekDeger()
    {
        return isset($this->EkSecenekDeger) ? $this->EkSecenekDeger : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEkSecenekDeger method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEkSecenekDeger method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEkSecenekDegerForArrayConstraintsFromSetEkSecenekDeger(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEkSecenekDegerEkSecenekDegerItem) {
            // validation for constraint: itemType
            if (!$arrayOfEkSecenekDegerEkSecenekDegerItem instanceof \StructType\EkSecenekDeger) {
                $invalidValues[] = is_object($arrayOfEkSecenekDegerEkSecenekDegerItem) ? get_class($arrayOfEkSecenekDegerEkSecenekDegerItem) : sprintf('%s(%s)', gettype($arrayOfEkSecenekDegerEkSecenekDegerItem), var_export($arrayOfEkSecenekDegerEkSecenekDegerItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EkSecenekDeger property can only contain items of type \StructType\EkSecenekDeger, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EkSecenekDeger value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EkSecenekDeger[] $ekSecenekDeger
     * @return \ArrayType\ArrayOfEkSecenekDeger
     */
    public function setEkSecenekDeger(array $ekSecenekDeger = array())
    {
        // validation for constraint: array
        if ('' !== ($ekSecenekDegerArrayErrorMessage = self::validateEkSecenekDegerForArrayConstraintsFromSetEkSecenekDeger($ekSecenekDeger))) {
            throw new \InvalidArgumentException($ekSecenekDegerArrayErrorMessage, __LINE__);
        }
        if (is_null($ekSecenekDeger) || (is_array($ekSecenekDeger) && empty($ekSecenekDeger))) {
            unset($this->EkSecenekDeger);
        } else {
            $this->EkSecenekDeger = $ekSecenekDeger;
        }
        return $this;
    }
    /**
     * Add item to EkSecenekDeger value
     * @throws \InvalidArgumentException
     * @param \StructType\EkSecenekDeger $item
     * @return \ArrayType\ArrayOfEkSecenekDeger
     */
    public function addToEkSecenekDeger(\StructType\EkSecenekDeger $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EkSecenekDeger) {
            throw new \InvalidArgumentException(sprintf('The EkSecenekDeger property can only contain items of type \StructType\EkSecenekDeger, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EkSecenekDeger[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EkSecenekDeger|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EkSecenekDeger|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EkSecenekDeger|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EkSecenekDeger|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EkSecenekDeger|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EkSecenekDeger
     */
    public function getAttributeName()
    {
        return 'EkSecenekDeger';
    }
}
